//+------------------------------------------------------------------+
//|                                                        Bulls.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//mod
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 DarkGreen
#property indicator_color2 Maroon
#property indicator_color3 Blue
#property indicator_color4 DarkOrange
#property indicator_width1 2  
#property indicator_style3 2  
#property indicator_style4 2  

//---- input parameters
extern string TimeFrame       = "Current time frame";
extern int BullsBearsPeriod=13;
extern int BullsBearsMAPeriod=5;
extern int SignalSMA=3;
//---- buffers
double BullsBuffer[];
double BearsBuffer[];
double BullsSignal[];
double BearsSignal[];
double TempBuffer[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BullsBuffer);
   SetIndexBuffer(1,BearsBuffer);
   SetIndexBuffer(2,BullsSignal);
   SetIndexBuffer(3,BearsSignal);
   SetIndexBuffer(4,TempBuffer);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" BullsBears ("+BullsBearsPeriod+") ma "+BullsBearsMAPeriod);
   return(0);
}

//+------------------------------------------------------------------+
//| Bulls Power                                                      |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { BullsBuffer[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         TempBuffer[i]  = iMA(NULL,0,BullsBearsPeriod,0,MODE_EMA,PRICE_CLOSE,i);
         BullsBuffer[i] = iMA(NULL,0,BullsBearsMAPeriod,0,MODE_EMA,PRICE_HIGH,i)-TempBuffer[i];
         BearsBuffer[i] = iMA(NULL,0,BullsBearsMAPeriod,0,MODE_EMA,PRICE_LOW,i) -TempBuffer[i];
      }
      for(i=limit; i>=0; i--)
      {
          BullsSignal[i]=iMAOnArray(BullsBuffer,Bars,SignalSMA,0,MODE_SMA,i);
          BearsSignal[i]=iMAOnArray(BearsBuffer,Bars,SignalSMA,0,MODE_SMA,i);
      }
      return(0);
   }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         BullsBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullsBearsPeriod,BullsBearsMAPeriod,SignalSMA,0,y);
         BearsBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullsBearsPeriod,BullsBearsMAPeriod,SignalSMA,1,y);
         BullsSignal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullsBearsPeriod,BullsBearsMAPeriod,SignalSMA,2,y);
         BearsSignal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullsBearsPeriod,BullsBearsMAPeriod,SignalSMA,3,y);
   }   
   
}   

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}